
; @access public
; @param A - length of Data Set
; @return void
c64unit_PrepareDataSetLength
	sta c64unit_DataSetLength+1
	lda #0
	sta c64unit_dataSetIterator
rts


; @access public
; @param X - lo-byte address of Data Set
; @param Y - hi-byte address of Data Set
; @return A - value
c64unit_GetDataSet
	stx c64unit_GetDataSetPointer+1
	sty c64unit_GetDataSetPointer+2
	
	ldy c64unit_dataSetIterator
c64unit_GetDataSetPointer
	lda $1234,y
rts


; Gets word from given Data Set memory location and puts into output memory location
; which needs to be set beforehand in c64unit_PrepareDataSetWordOutput method
; 
; @access public
; @param X - lo-byte address
; @param Y - hi-byte address
; @return void
c64unit_GetDataSetWord .proc
	stx input + 1
	sty input + 2
	
	lda c64unit_dataSetIterator
	asl
	tay
	ldx #0
-
input
	lda $1234,y
outputPointer
	sta $1234,x
	iny
	inx
	cpx #2
	bne -
rts

.pend


; Gets word from given Data Set memory location and puts into output memory location for lo and hi byte
; which needs to be set beforehand in c64unit_PrepareDataSetWordToLoHiOutput method
; 
; @access public
; @param X - lo-byte address
; @param Y - hi-byte address
; @return void
c64unit_GetDataSetWordToLoHi .proc
	stx inputForLoPart + 1
	sty inputForLoPart + 2
	stx inputForHiPart + 1
	sty inputForHiPart + 2
	
	lda c64unit_dataSetIterator
	asl
	tay
inputForLoPart
	lda $1234,y
outputPointerForLoPart
	sta $1234
	
	iny
inputForHiPart
	lda $1234,y
outputPointerForHiPart
	sta $1234
rts

.pend


; @access public
; @return true for zero flag if completed
c64unit_IsDataSetCompleted
	inc c64unit_dataSetIterator
	lda c64unit_dataSetIterator
c64unit_DataSetLength
	cmp #0
rts


; Prepares memory location for word which will be taken from Data Set
; 
; @access public
; @param X - lo-byte address
; @param Y - hi-byte address
; @return void
c64unit_PrepareDataSetWordOutput
	stx c64unit_GetDataSetWord.outputPointer + 1
	sty c64unit_GetDataSetWord.outputPointer + 2
rts


; Prepares memory location for word which will be taken from Data Set
; It's used within c64unit_GetDataSetWordToLoHi which allocates the hi part destination
; 
; @access public
; @param X - lo-byte address
; @param Y - hi-byte address
; @return void
c64unit_PrepareDataSetWordHiOutput
	stx c64unit_GetDataSetWordToLoHi.outputPointerForHiPart + 1
	sty c64unit_GetDataSetWordToLoHi.outputPointerForHiPart + 2
rts


; Prepares memory location for word which will be taken from Data Set
; It's used within c64unit_GetDataSetWordToLoHi which allocates the lo part destination
; 
; @access public
; @param X - lo-byte address
; @param Y - hi-byte address
; @return void
c64unit_PrepareDataSetWordLoOutput
	stx c64unit_GetDataSetWordToLoHi.outputPointerForLoPart + 1
	sty c64unit_GetDataSetWordToLoHi.outputPointerForLoPart + 2
rts
